/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.47 by edhill, Tue Aug 3 02:48:57 2004 UTC revision 1.98 by jmc, Wed Sep 12 21:50:21 2007 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mth)                   run multi threaded (using eedata.mth)"
15        echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
19      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
20      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"edhill@mitgcm.org\")"
21      echo "  (-t|-tdir) STRING        list of test dirs to use"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
22      echo "                             (DEF=\"\" which builds all)"      echo "                             (recognized groups: basic, tutorials)"
23        echo "                             (DEF=\"\" which test all)"
24        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
25        echo "                             (DEF=\"\" which test all)"
26      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
27      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
28      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
# Line 27  usage() Line 31  usage()
31      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
32      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
33      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
34        echo "  (-odir) STRING           used to build output directory name"
35        echo "                             (DEF=\"hostname\")"
36        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
37        echo "                             (DEF=\"1 2 3 4 5\")"
38        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
39        echo "                             (DEF=\"12\")"
40      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
41      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
42      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
# Line 34  usage() Line 44  usage()
44      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
45      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
46      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
47        echo "  (-ts)                    provide timing information per timestep"
48        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
49        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
50      echo      echo
51      echo "and where STRING follows a whitespace-delimited format"      echo "and where STRING can be a whitespace-delimited list"
52      echo "such as:"      echo "such as:"
53        echo
54      echo "  -t 'exp0 exp2 exp3' "      echo "  -t 'exp0 exp2 exp3' "
55      echo "  -addr='abc@123.com testing@home.org'"      echo "  -addr='abc@123.com testing@home.org'"
56      echo      echo
57        echo "provided that the expression is properly quoted within the current"
58        echo "shell (note the use of single quotes to protect white space)."
59        echo
60      exit 1      exit 1
61  }  }
62    
# Line 77  build_mpack() Line 94  build_mpack()
94      echo "OK"      echo "OK"
95  }  }
96    
97  testoutput_for_prop()  testoutput_var()
98  {  {
99      # testoutput_for_prop dir s1 label subdir extension      # testoutput_var dir s1 label subdir extension
100      #      #
101      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
102      #  using search strings s1 and text label      #     with same output from reference file $dir/results/output.$extension
103        #  using search strings s1 and text label
104    
105      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
106          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
107      fi      fi
108      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
109          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
110          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
111          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 3 ]; then
112              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
113                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
114              fi              fi
115              return 99              return 99
116          fi          fi
117      else      else
118          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
119          return 99          return 99
120      fi      fi
121      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
122          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_var: grep "$2" $1/results/output.$5 1>&2
123      fi      fi
124      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/output.$5 | sed 's/.*=//' | cat -n > tmp2.txt
125      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
126      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 3 ]; then
127          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
128              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
129          fi          fi
130          return 99          return 99
131      fi      fi
132        if [ $lncntA -ne $lncntB ]; then
133            if [ $verbose -gt 0 ]; then
134                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
135            fi
136            return 99
137        fi
138        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
139        if [ $has_nan -gt 0  ] ; then
140            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
141            return 99
142        fi
143        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
144        if [ $has_inf -gt 0  ] ; then
145            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
146            return 99
147        fi
148      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
149          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
150      fi      fi
151      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
152      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
153          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
154      fi      fi
155      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
156          cat tmp3.txt 1>&2          cat tmp3.txt 1>&2
# Line 124  testoutput_for_prop() Line 158  testoutput_for_prop()
158      echo "-1" >> tmp3.txt      echo "-1" >> tmp3.txt
159      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
160      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
161      digits_of_similarity=`./tmp_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
162      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
163          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
164              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$2\" 1>&2
165          fi          fi
166          digits_of_similarity=99          digits_of_similarity=99
167      else      else
# Line 157  dashnum() Line 191  dashnum()
191    
192  testoutput_ad()  testoutput_ad()
193  {  {
194      grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt      grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt
195      grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt      grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $5}' > t15.txt
196      grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt      grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt
197      grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt      grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $6}' > t16.txt
198      join t05.txt t15.txt > t5.txt      join t05.txt t15.txt > t5.txt
199      join t06.txt t16.txt > t6.txt      join t06.txt t16.txt > t6.txt
200      echo "-1" >> t5.txt      echo "-1" >> t5.txt
201      echo "-1" >> t6.txt      echo "-1" >> t6.txt
202      digits_5=`./tmp_cmpnum < t5.txt`      digits_5=`./tr_cmpnum < t5.txt`
203      digits_6=`./tmp_cmpnum < t6.txt`      digits_6=`./tr_cmpnum < t6.txt`
204      dashnum $digits_5 $digits_6      dashnum $digits_5 $digits_6
205      rm -f t[01][56].txt t[56].txt      rm -f t[01][56].txt t[56].txt
206  }  }
207    
208  testoutput()  check_for_add_mon_output()
209    {
210        # Check for additional types of monitor output
211        if test "x$1" = x ; then
212            return
213        fi
214    
215        for ii in $PTRACERS_NUM ; do
216            eval "HAVE_PTR0"$ii"=f"
217        done
218    
219        ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"
220        ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
221        for ii in $PTRACERS_NUM ; do
222            for jj in $ptr_add ; do
223                name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
224                tst=`grep $name $1 | wc -l | awk '{print $1}'`
225                if test ! "x$tst" = x0 ; then
226                    eval "HAVE_PTR0"$ii"=t"
227                fi
228            done
229            #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'
230        done
231    }
232    
233    testoutput_run()
234  {  {
235      # testoutput directory subdir extension      # testoutput_run directory subdir extension
236      #      #
237      #  test output in "directory"      #  test output from 1 run in "directory"
238      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
239          if [ $debug -gt 0 ]; then          # default list of output variables to be checked:
240              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2          #  1rst : main variable used to decide if it pass or FAIL
241          fi          #  others : number of matching digits to be printed in summary.txt
242          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?          listChk=$DEF_CHECK_LIST
243          if [ $debug -gt 0 ]; then          #  load experiment-specific list from file "tr_checklist" (if it exist)
244              echo testoutput: cg2dres=$cg2dres 1>&2          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
245          fi          sVar=`echo $listChk | awk '{print $1}'`
246          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?          # remove 1rst var and expand the list: + => min max mean s.d
247          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
248          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?                                 | sed 's/+//g' | sed "s/^$sVar//"`
249          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
250          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?          for ii in 1 2 3 4 5 6 7 8 9 ; do
251          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`
252          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
253          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi
254          testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?          done
255          testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`
256          testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?          if test $tst != 1 ; then
257          testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
258          testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
259          testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?            echo "==> WARNING: in checked list:" $listVar 1>&2
260          testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?          #- put it back once:
261          testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
262          dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \          fi
263              $umin $umax $umean $usd $vmin $vmax $vmean $vsd          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
264            echo "listVar='$listVar'" > $CDIR"/summary.txt"
265            allargs=""
266            for xx in $listVar
267            do
268              case $xx in
269               'PS')  if [ $debug -gt 0 ]
270                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
271                      testoutput_var $1 "cg2d_init_res" "cg2d init. residual" $2 $3; yy=$?
272                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
273               'Tmn') testoutput_var $1 "dynstat_theta_min"  "theta minimum"  $2 $3; yy=$? ;;
274               'Tmx') testoutput_var $1 "dynstat_theta_max"  "theta maximum"  $2 $3; yy=$? ;;
275               'Tav') testoutput_var $1 "dynstat_theta_mean" "theta mean"     $2 $3; yy=$? ;;
276               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "theta s.d."     $2 $3; yy=$? ;;
277               'Smn') testoutput_var $1 "dynstat_salt_min"  "salt minimum"    $2 $3; yy=$? ;;
278               'Smx') testoutput_var $1 "dynstat_salt_max"  "salt maximum"    $2 $3; yy=$? ;;
279               'Sav') testoutput_var $1 "dynstat_salt_mean" "salt mean"       $2 $3; yy=$? ;;
280               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "salt s.d."       $2 $3; yy=$? ;;
281               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
282               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
283               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
284               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U s.d."          $2 $3; yy=$? ;;
285               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
286               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
287               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
288               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V s.d."          $2 $3; yy=$? ;;
289            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
290               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
291            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
292               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
293            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
294               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
295            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
296               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_sd"    $2 $3; yy=$? ;;
297                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
298              esac
299              if test $xx = $sVar
300              then allargs="$allargs > $yy <"
301              else allargs="$allargs $yy"
302              fi
303            done
304    
305            nbVar=`echo $listVar | awk '{print NF}'`
306            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
307            #-- fill line (up to standard length) with dot:
308              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
309              echo $allargs $adNul
310            else
311              echo $allargs
312            fi
313    
314      else      else
315          testoutput_ad $1 $2 "precision_grdchk_result"          testoutput_ad $1 $2 "precision_grdchk_result"
316      fi      fi
# Line 225  genmakemodel() Line 334  genmakemodel()
334                  command="$command --mods=../code"                  command="$command --mods=../code"
335              else              else
336                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
                 command="$command -adof=../../../tools/adjoint_options/adjoint_staf"  
337              fi              fi
338              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
339                  command="$command --optfile=$OPTFILE"                  command="$command --optfile=$OPTFILE"
# Line 233  genmakemodel() Line 341  genmakemodel()
341              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
342                  command="$command -ieee"                  command="$command -ieee"
343              fi              fi
344                if test "x$MPI" = xt ; then
345                    command="$command -mpi"
346                fi
347                if test "x$TS" = xt ; then
348                    command="$command -ts"
349                fi
350                if test "x$PAPIS" = xt ; then
351                    command="$command -papis"
352                else
353                if test "x$PCLS" = xt ; then
354                    command="$command -pcls"
355                fi
356                fi
357              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
358              $command > make.log 2>&1              $command > make.log 2>&1
359              RETVAL=$?              RETVAL=$?
# Line 254  makeclean() Line 375  makeclean()
375  {  {
376      # makeclean directory      # makeclean directory
377      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
378          echo "make CLEAN skipped!"          echo "make Clean skipped!"
379      else      else
380          (          (
381              cd $1;              cd $1;
382              if test -e output.txt ; then              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
                 rm -f output.txt  
             fi  
             printf 'make CLEAN ... ' 2>&1  
383              if test -r Makefile ; then              if test -r Makefile ; then
384                  $MAKE CLEAN >> make.log 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
385                    $MAKE Clean >> make.log 2>&1
386                  RETVAL=$?                  RETVAL=$?
387                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
388                      tail make.log                      tail make.log
389                      echo "makeclean: \"make CLEAN\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed" 1>&2
390                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
391                      return 1                      return 1
392                  fi                  fi
# Line 278  makeclean() Line 397  makeclean()
397      fi      fi
398  }  }
399    
400    run_clean()
401    {
402        # run_clean directory
403        if test "x$NOCLEAN" = xt ; then
404            echo "run_clean skipped!"
405        else
406            (
407                cd $1;
408                printf 'clean run-dir ... ' 2>&1
409                # part of what is done after "make clean" when doing "make CLEAN"
410                find . -name "*.meta" -exec rm {} \;
411                find . -name "*.data" -exec rm {} \;
412                find . -name "fort.*" -exec rm {} \;
413                find . -type l -exec rm {} \;
414                rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
415                rm -rf mnc_test_*
416                echo successful 1>&2
417                exit 0
418            )
419        fi
420    }
421    
422  makedependmodel()  makedependmodel()
423  {  {
424      # makedependmodel directory      # makedependmodel directory
# Line 380  symlink_mpifiles() Line 521  symlink_mpifiles()
521    
522  linkdata()  linkdata()
523  {  {
524      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
525      #      #
526      # symbolically link data files to run directory      # symbolically link data files to run directory
527      if test "x$1" = x1 ; then      if test -d $1 ; then
528          (          (
529              cd $2              cd $1 ; shift
530              if test "x$ADM" = x ; then              if test -r "../"$1"/eedata.mth" ; then
531                  files=`( cd ../input ; ls -1 | grep -v CVS )`              # found eedata.mth in 1rst input dir and it is readable
532                  for i in $files ; do                  if test "x$MULTI_THREAD" = "xt" ; then
533                      if test ! -d "../input/"$i ; then                  # multi-threaded test: remove symbolic link & link eedata.mth
534                          ln -sf "../input/"$i $i                      if test -h eedata ; then rm -f eedata ; fi
535                        if test ! -r eedata ; then
536                            ln -sf "../"$1"/eedata.mth" eedata ;
537                            printf 'eedata.mth ' 1>&2
538                      fi                      fi
539                  done                  else
540              else                  # not multi-threaded test: remove eedata symbolic link
541                  files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`                      if test -h eedata ; then rm -f eedata ; fi
542                  for i in $files ; do                  fi
                     if test ! -d "../input/"$i ; then  
                         ln -sf "../input/"$i $i  
                     fi  
                 done  
                 files=`( cd ../input_ad ; ls -1 | grep -v CVS )`  
                 for i in $files ; do  
                     if test ! -d "../input_ad/"$i ; then  
                         ln -sf "../input_ad/"$i $i  
                     fi  
                 done  
543              fi              fi
544                for ldir in $* ; do
545                    if test -d "../"$ldir ; then
546                        printf 'ldir='${ldir} 1>&2
547                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
548                        for i in $files ; do
549                            if test ! -d "../"$ldir/$i ; then
550                                if test ! -r $i  ; then
551                                    printf ' '$i 1>&2
552                                    ln -sf "../"$ldir"/"$i $i
553                                fi
554                            fi
555                        done
556                        if test -x "../"$ldir"/"prepare_run ; then
557                            "../"$ldir"/"prepare_run
558                        fi
559                        printf ' ; ' 1>&2
560                    fi
561                done
562          )          )
563      fi      fi
564  }  }
# Line 419  runmodel() Line 571  runmodel()
571      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
572      (      (
573          cd $1          cd $1
574          printf 'runmodel ... ' 1>&2          printf 'runmodel in %s ...' $1 1>&2
575          # make output.txt          # make output.txt
576          echo          echo
577          rm -f run.log          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
578          # echo "COMMAND='$COMMAND'"              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00
579          # echo "pwd='"`pwd`"'"              ln -sf "../"$builddir"/"$EXECUTABLE .
580          ( eval $COMMAND ) > run.log 2>&1          fi
581          RETVAL=$?          if test ! -x $EXECUTABLE ; then
582          if test "x$RETVAL" = x0 ; then                  rm -f run.log ; touch run.log
583                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
584                    echo " no executable:" $EXECUTABLE >> run.log
585                    RETVAL=8
586                    ENDVAL=-1
587            else
588                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
589                  # output do not exist or is older than executable:
590                    rm -f run.log ; touch run.log
591                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
592                    ( eval $COMMAND ) >> run.log 2>&1
593                    RETVAL=$?
594                else
595                    RETVAL=0
596                    if test -f run.log ; then
597                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
598                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
599                    else
600                        touch run.log
601                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
602                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
603                        echo " no previous run.log: assume NORMAL END" >> run.log 2>&1
604                    fi
605                fi
606                ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
607            fi
608            rm -f run.log_00
609            #if test "x$RETVAL" = x0 ; then
610            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
611              tail run.log              tail run.log
612              echo successful 1>&2              echo successful 1>&2
613              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
614              # if test "x$ADM" = x ; then              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
615              #   cp output.txt $CDIR"/output.txt"              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
             # else  
             #   cp output.txt_adm $CDIR"/output.txt_adm"  
             # fi  
616              return 0              return 0
617          else          else
618              tail run.log              tail run.log
619              echo failed 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
620              cp run.log $CDIR"/run.log"              cp run.log $CDIR"/run.log"
621                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
622              return 1              return 1
623          fi          fi
624      )      )
# Line 451  createcodelet() Line 629  createcodelet()
629      # create codelet for comparing model output      # create codelet for comparing model output
630    
631      printf "creating the comparison code...  "      printf "creating the comparison code...  "
632      cat > tmp_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
633  #include <stdio.h>  #include <stdio.h>
634  #include <math.h>  #include <math.h>
635  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
636    int linnum,best,lncnt;    int linnum,cmplin,best,lncnt;
637    double a,b,diff;    double a,b,abave,relerr;
638    best = -16;    best = -22;
639    lncnt = 0;    lncnt = 0;
640    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
641      scanf("%d", &linnum);      scanf("%d", &linnum);
642      if (linnum == -1)  break;      if (linnum == -1)  break;
643      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
644      diff = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
645      if (diff > 1.e-12) {      if ( abave == abave ) {
646        diff=fabs(a-b)/diff;        if (abave > 0.0) {
647        if (diff > 0.0) {          relerr=fabs(a-b)/abave;
648          linnum = (int)log10(diff);          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
649          best = (best > linnum) ? best : linnum;          else { cmplin = -16 ; }
650        }          best = (best > cmplin) ? best : cmplin; }
651        else {        else { cmplin = -22 ; }
652          if (best == -16 && diff != 0)  best = -22;     /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
653        }        }
654      }     else {
655       /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
656          break; }
657    }    }
658    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
659      if (linnum != -1) best=-99;
660    printf("%d\n", -best);    printf("%d\n", -best);
661    return 0;    return 0;
662  }  }
663  EOF  EOF
664      cc -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tr_cmpnum tr_cmpnum.c -lm
665    
666      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tr_cmpnum ]; then
667          echo "OK"          echo "OK"
668          return 0          return 0
669      else      else
670          echo          echo
671          echo "ERROR: failed to compile comparison code"          echo "ERROR: failed to compile comparison code -- please specify"
672            echo "  a C compiler using the CC environment variable."
673          exit 1          exit 1
674      fi      fi
675  }  }
# Line 499  formatresults() Line 681  formatresults()
681      nm=$1      nm=$1
682      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
683      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
684      printf '%3s' $@      listPrt=$@
685        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
686        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
687        printf '%3s' $listPrt
688    #   line below does not work on hp-ux_ia64 : do those substitutions later on
689    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
690            
691      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
692            printf ' N/O '
693        elif [ $xx = '--' ]; then
694            printf ' N/O '
695        elif [ $xx = 99 ]; then
696          printf ' N/O '          printf ' N/O '
697      else      else
698          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
699              printf ' pass'              printf ' pass'
700          else          else
701              printf ' FAIL'              printf ' FAIL'
# Line 515  formatresults() Line 706  formatresults()
706            
707  }  }
708    
 show_help()  
 {  
     cat - << EOF  
 $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]  
   
  -help|-h      Show this help message  
  -quiet     Reduce the amount of output  
  -verbose   Produce copious amounts of output  
  -debug     Produce even more output which will mean nothing to most  
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
 }  
   
709  scandirs()  scandirs()
710  {  {
711      if [ $# -eq 0 ]; then      if [ $# -eq 1 ]; then
712          for arg in * ; do          for arg in * ; do
713              test -d $arg/input && echo $arg              test -d $arg/$1 && echo $arg
714          done          done
715      else      else
716          echo $*          echo $*
717      fi      fi
718  }  }
719    
# Line 567  QUICK=f Line 739  QUICK=f
739  NOGENMAKE=f  NOGENMAKE=f
740  NOCLEAN=f  NOCLEAN=f
741  NODEPEND=f  NODEPEND=f
742    POSTCLEAN=f
743    
744  BASH=  BASH=
745  OPTFILE=NONE  OPTFILE=NONE
746  ADDRESSES=  ADDRESSES=
747  TESTDIRS=  TESTDIRS=
748    SKIPDIRS=
749  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
750  HAVE_MPACK=  HAVE_MPACK=
751  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
752  COMMAND=  COMMAND=
753  MAKE=make  if test "x$MAKE" = x ; then
754        MAKE=make
755    fi
756    if test "x$CC" = x ; then
757        CC=cc
758    fi
759  JOBS=  JOBS=
760  MPI=f  MPI=f
761    MULTI_THREAD=f
762    OUTDIR=
763  DELDIR=  DELDIR=
764    
765  ADM=  ADM=
766    
767    # Additional monitor types
768    PTRACERS_NUM="1 2 3 4 5"
769    
770    MATCH_CRIT=13
771    
772  printf "parsing options...  "  printf "parsing options...  "
773    
774  ac_prev=  ac_prev=
# Line 617  for ac_option ; do Line 803  for ac_option ; do
803          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
804              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
805    
806            -skipdir | --skipdir | -skd | --skd)
807                ac_prev=SKIPDIRS ;;
808            -skipdir=* | --skipdir=*)
809                SKIPDIRS=$ac_optarg ;;
810    
811          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
812              ac_prev=BASH ;;              ac_prev=BASH ;;
813          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 632  for ac_option ; do Line 823  for ac_option ; do
823          -make=* | --make=*)          -make=* | --make=*)
824              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
825    
826            -odir | --odir)
827                ac_prev=OUTDIR ;;
828            -odir=* | --odir=*)
829                OUTDIR=$ac_optarg ;;
830    
831            -ptracers | --ptracers | -ptr | --ptr)
832                ac_prev=PTRACERS_NUM ;;
833            -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
834                PTRACERS_NUM=$ac_optarg ;;
835    
836            -match | --match ) ac_prev=MATCH_CRIT ;;
837            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
838    
839          -j) ac_prev=JOBS ;;          -j) ac_prev=JOBS ;;
840          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
841    
842          -clean | --clean)          -clean | --clean)
843              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
844    
845          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
846              QUICK=t ;;              QUICK=t ;;
# Line 647  for ac_option ; do Line 851  for ac_option ; do
851          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
852              NODEPEND=t ;;              NODEPEND=t ;;
853    
854            -postclean | --postclean | -pc | --pc)
855                POSTCLEAN=t ;;
856    
857          -mpi) MPI=t ;;          -mpi) MPI=t ;;
858    
859            -mth) MULTI_THREAD=t ;;
860    
861          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
862    
863          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
# Line 660  for ac_option ; do Line 869  for ac_option ; do
869    
870          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
871    
872            -ts) TS=t;;
873    
874            -papis) PAPIS=t;;
875    
876            -pcls) PCL=t;;
877    
878          -*)          -*)
879              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
880              usage              usage
# Line 681  if test "x$QUICK" = xt ; then Line 896  if test "x$QUICK" = xt ; then
896  fi  fi
897    
898  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
899      TESTDIRS=`scandirs`      if test "x$ADM" = xt ; then
900            LIST=`scandirs results_ad`
901        else
902            LIST=`scandirs results`
903        fi
904    else
905        #- expand group of experiments:
906        LIST=" "
907        for xx in $TESTDIRS
908        do
909          case $xx in
910            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
911                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
912                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
913                    ;;
914            'tutorials')
915                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
916            *)       LIST=${LIST}" "$xx ;;
917          esac
918        done
919  fi  fi
920    #echo 'LIST='${LIST}'<'
921    #- skip dirs, remove duplicate and non-directory:
922    TESTDIRS=" "
923    count=0
924    for xx in $LIST
925    do
926        yy=`echo $SKIPDIRS | grep -c $xx`
927        if test $yy = 0 ; then
928            if test -d $xx ; then
929                yy=`echo $TESTDIRS | grep -c $xx`
930                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
931            else count=1 ;
932                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
933            fi
934        else
935            if test $count = 1 ; then echo -n ", \"$xx\""
936            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
937            fi
938        fi
939    done
940    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
941    #echo 'TESTDIRS='${TESTDIRS}'<'
942    
943  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
944      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
945  fi  fi
946    
947  if test "x$ADM" = xt -a "x$COMMAND" = x ; then  if test "x$ADM" = xt ; then
948      COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"      EXECUTABLE="mitgcmuv_ad"
949        OUTPUTFILE="output_adm.txt"
950    else
951        EXECUTABLE="mitgcmuv"
952        OUTPUTFILE="output.txt"
953  fi  fi
954    
955  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
956      COMMAND="$MAKE output.txt"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
957  fi  fi
958    if test "x$MPI" = xt ; then
959        OUTPUTFILE="STDOUT.0000"
960    fi
961    
962    #echo "OK"
963    echo "OK (COMMAND= $COMMAND )"
964    
965  echo "OK"  # set the Default List of output variables to be checked:
966    #  (use default or load experiment-specific list from file "tr_checklist")
967    # content : 1rst = main variable used to decide if it pass or FAIL
968    #         others = number of matching digits to be printed in summary.txt
969    if test "x$ADM" != xt ; then
970        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
971        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
972        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
973        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
974        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
975    fi
976    
977  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
978  createcodelet  createcodelet
# Line 713  MACH=`hostname` Line 989  MACH=`hostname`
989  UNAMEA=`uname -a`  UNAMEA=`uname -a`
990  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
991  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
992    if test "x$OUTDIR" != x ; then
993        BASE="tr_"$OUTDIR"_"$DATE"_"
994    fi
995  DNUM=0  DNUM=0
996  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
997  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 758  fi Line 1037  fi
1037  echo  echo
1038  echo >> $SUMMARY  echo >> $SUMMARY
1039  if test "x$ADM" = x ; then  if test "x$ADM" = x ; then
1040      cat << EOF | tee -a $SUMMARY      if [ $MATCH_CRIT -lt 10 ] ;
1041                  T           S           U           V      then line_0="default  "$MATCH_CRIT ;
1042  G D M    c        m  s        m  s        m  s        m  s      else line_0="default "$MATCH_CRIT ; fi
1043  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1044  N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1045  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .      line_1="G D M    c        m  s        m  s        m  s        m  s"
1046        line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1047  EOF      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1048        line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1049        for ii in $PTRACERS_NUM ; do
1050            #  tst=`eval 'echo $HAVE_PTR0'$ii`
1051            #  if test "x$tst" = xt ; then
1052            line_0="$line_0  --PTR 0"$ii"--"
1053            line_1="$line_1        m  s"
1054            line_2="$line_2  m  m  e  ."
1055            line_3="$line_3  i  a  a  d"
1056            line_4="$line_4  n  x  n  ."
1057            #  fi
1058        done
1059        echo "$line_0" | tee -a $SUMMARY
1060        echo "$line_1" | tee -a $SUMMARY
1061        echo "$line_2" | tee -a $SUMMARY
1062        echo "$line_3" | tee -a $SUMMARY
1063        echo "$line_4" | tee -a $SUMMARY
1064        echo " "       | tee -a $SUMMARY
1065  else  else
1066      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1067      echo >> $SUMMARY      echo >> $SUMMARY
# Line 784  for dir in $TESTDIRS ; do Line 1080  for dir in $TESTDIRS ; do
1080      #  Cleanup only!      #  Cleanup only!
1081      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1082          if test -r $dir/build/Makefile ; then          if test -r $dir/build/Makefile ; then
1083                echo '  ------  clean dir:' $dir/build
1084              ( cd $dir/build ; make CLEAN )              ( cd $dir/build ; make CLEAN )
1085          fi          fi
1086          if test -r $dir/input/Makefile ; then          if test -d $dir/run/CVS ; then
1087              ( cd $dir/input ; make CLEAN )              echo '  ------  clean dir:' $dir/run
1088                run_clean $dir/run
1089          fi          fi
1090            (
1091                cd $dir
1092                rm -rf tr_run.*
1093            )
1094          continue          continue
1095      fi      fi
1096    
# Line 798  for dir in $TESTDIRS ; do Line 1100  for dir in $TESTDIRS ; do
1100      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
1101          fout=$dir"/results/output.txt"          fout=$dir"/results/output.txt"
1102      else      else
1103          fout=$dir"/results_ad/output.txt_adm"          fout=$dir"/results_ad/output_adm.txt"
1104      fi      fi
1105      if test ! -r $fout ; then      if test ! -r $fout ; then
1106          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1107          continue          continue
1108      fi      fi
1109        if test "x$ADM" = x ; then
1110            check_for_add_mon_output  $fout
1111        fi
1112    
1113        # Check for additional types of monitor output
1114    
1115      builddir="input"      builddir="build"
1116      rundir="input"      if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1117      use_seperate_build=0      rundir="run"
1118      if test -d $dir/build -a -r $dir/build ; then     #rundir=$builddir
1119          builddir="build"      if test ! -d $dir/$rundir ; then
1120          rundir="build"          rundir=$builddir
         use_seperate_build=1  
         linkdata $use_seperate_build $dir/$rundir  
1121      fi      fi
1122            
     #  Check whether there are "extra runs" for this testdir  
     extra_runs=  
     if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then  
         ex_run_dirs=`( cd $dir ; echo input.* )`  
         echo "ex_run_dirs='$ex_run_dirs'"  
         for exd in $ex_run_dirs ; do  
             name=`echo $exd | sed -e 's/input.//g'`  
             outf="$dir/results/output.txt.$name"  
             if test -f $outf -a -r $outf ; then  
                 extra_runs="$extra_runs $name"  
             fi  
         done  
     fi  
   
1123      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
1124          code_dir=code          code_dir=code
1125          CODE_DIR=$dir/code          CODE_DIR=$dir/code
1126            input_dirs='input'
1127      else      else
1128          code_dir=code_ad          code_dir=code_ad
1129          CODE_DIR=$dir/code_ad          CODE_DIR=$dir/code_ad
1130            input_dirs='input_ad input'
1131      fi      fi
1132      BUILD_DIR=$dir/$builddir      BUILD_DIR=$dir/$builddir
1133    
# Line 842  for dir in $TESTDIRS ; do Line 1135  for dir in $TESTDIRS ; do
1135          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1136          continue          continue
1137      fi      fi
1138        if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1139            echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1140            continue
1141        fi
1142    
1143        #  Check whether there are "extra runs" for this testdir
1144        extra_runs=
1145        if test "x$ADM" = x ; then
1146            ex_run_dirs=`( cd $dir ; echo input.* )`
1147            #echo "ex_run_dirs='$ex_run_dirs'"
1148            for exd in $ex_run_dirs ; do
1149                name=`echo $exd | sed -e 's/input.//g'`
1150                outf="$dir/results/output.$name.txt"
1151                if test -f $outf -a -r $outf ; then
1152                    if test "x$MULTI_THREAD" = "xt" ; then
1153                        if test -r $dir"/"$exd"/eedata.mth" ; then
1154                            extra_runs="$extra_runs $name"
1155                        #else echo $dir"/"$exd"/eedata.mth: not found"
1156                        fi
1157                    else
1158                        extra_runs="$extra_runs $name"
1159                    fi
1160                fi
1161            done
1162        fi
1163    
1164      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1165      echo      echo
1166      echo "Experiment:  $dir"      if test "x$extra_runs" = "x" ; then
1167           echo "Experiment:  $dir"
1168        else
1169           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1170        fi
1171      echo      echo
1172      unset genmake makedepend make run      unset genmake makedepend make run
1173      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1174    
1175      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1176      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 856  for dir in $TESTDIRS ; do Line 1178  for dir in $TESTDIRS ; do
1178      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$rel_CDIR"
1179            
1180      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1181          makeclean $dir/$builddir          echo '====>>> this is to check that we never go through this part <<< ==='
1182            makeclean $dir/$builddir \
1183                && run_clean $dir/$rundir
1184      else      else
1185          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1186              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1187                && run_clean $dir/$rundir \
1188              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1189              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1190              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1191              && linkdata $use_seperate_build $dir/$rundir \              && linkdata $dir/$rundir $input_dirs \
1192              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1193              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir "txt"`
1194      fi      fi
1195            
1196      echo      echo
1197      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
1198          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1199          echo          echo
1200          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1201          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1202            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1203          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1204          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1205          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1206          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1207    
         OLD_COMMAND=$COMMAND  
         COMMAND="./mitgcmuv > output.txt"  
1208          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1209              test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"              unset run
1210              mkdir "$dir/tr_run.$ex"              results=$EMPTY_RESULTS
1211              links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`              #  Create an output dir for each OPTFILE/tdir.ex combination
1212              (              rel_CDIR=$DRESULTS"/"$dir"."$ex
1213                  cd "$dir/tr_run.$ex"              mkdir $rel_CDIR
1214                  for i in $links; do              CDIR=`pwd`"/$rel_CDIR"
1215                      ln -s ../input/$i $i              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1216                  done              run_clean $dir/tr_run.$ex
1217              )              linkdata $dir/tr_run.$ex input.$ex input
             links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`  
             (  
                 cd "$dir/tr_run.$ex"  
                 for i in $links; do  
                     test -e $i  &&  rm -f $i  
                     ln -s ../input.$ex/$i $i  
                 done  
                 ln -s ../$builddir/mitgcmuv mitgcmuv  
             )  
1218              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1219                  && results=`testoutput $dir tr_run.$ex "."$ex`                  && results=`testoutput_run $dir tr_run.$ex ${ex}".txt"`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1220              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1221              fres="$fres.$ex"              fres="$fres.$ex"
1222              echo              echo
1223              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1224              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1225                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1226              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1227              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1228              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1229              echo "tdir='$dir'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1230                if test "x$POSTCLEAN" = xt ; then
1231                    run_clean $dir/tr_run.$ex
1232                fi
1233          done          done
         COMMAND=$OLD_COMMAND  
1234      else      else
1235          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
1236          fres=$fres"$results   $dir"          fres=$fres"$results   $dir"
1237          echo          echo
1238          echo "$fres" >> $SUMMARY          echo "$fres" >> $SUMMARY
1239          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1240            echo "fresults='$fres'" >> $CDIR"/summary.txt"
1241          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1242          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1243          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1244          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1245            grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1246                               >> $CDIR"/summary.txt"
1247        fi
1248    
1249        #postclean $dir/$builddir
1250        if test "x$POSTCLEAN" = xt ; then
1251            makeclean $dir/$builddir \
1252                && run_clean $dir/$rundir
1253      fi      fi
1254            
1255      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
# Line 962  else Line 1288  else
1288      fi      fi
1289  fi  fi
1290    
1291  # rm -f tmp_cmpnum.f a.out  rm -f tr_cmpnum.c tr_cmpnum
 rm -f tmp_cmpnum.c tmp_cmpnum  
1292    
1293  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1294      cat $SUMMARY      cat $SUMMARY | sed 's/  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.//'
1295      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1296          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1297      fi      fi
1298      cat $SUMMARY > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/  \.//g' > tr_out.txt
1299  fi  fi
1300    
1301  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.47  
changed lines
  Added in v.1.98

  ViewVC Help
Powered by ViewVC 1.1.22